<?php
function processpayroll($exportid) {
	if (isset($exportid)) {
		$conn = connect();
		$sql  = "SELECT * FROM payroll WHERE id =" . $exportid . " and deleted = 0;";
		$pres = $conn->query($sql) or die('<br/>Error in query string:<br/>' . $sql . '<br/>');
		$prow = $pres->fetch(PDO::FETCH_ASSOC);
		reset($prow);
		$pfromdate = $prow["fromdate"];
		$ptodate   = $prow["todate"];

		$payrollhours = processpayrollhours($prow, $payrollhours, $pfromdate, $ptodate);
		/* First process all employees for one payroll type*/
	} else {
		global $conn;
		global $fromdate;
		global $todate;
		$pfromdate = string2date(1, 0, 0, 0, $fromdate, 0);
		$ptodate   = string2date(1, 0, 0, 0, $todate, 0);

		$prow["id"]   = "0";
		$payrollhours = processpayrollhours($prow, $payrollhours, $pfromdate, $ptodate);
		/* First process all employees who are not assigned to a payroll type*/

		$sql = "SELECT * FROM payroll where deleted = 0;";
		$pres = $conn->query($sql) or die('<br/>Error in query string:<br/>' . $sql . '<br/>');
		while ($prow = $pres->fetch(PDO::FETCH_ASSOC)) {
			/* Get processor settings from payroll file */
			$payrollhours = processpayrollhours($prow, $payrollhours, $pfromdate, $ptodate);
		}
	}
	$_SESSION["payrollhours"] = $payrollhours;
	/* Store payroll hours in session to be used by main thread to have it displayed */
}

function processpayrollhours($prow, $payrollhours, $pfromdate, $ptodate){
	$res = sql_select($prow, $pfromdate, $ptodate);
	unset($phours["empnumber"]);
	unset($gethoursorder);
	/* Get order of processor settings from array already created */
	for ($c = 1; $c <= 4; $c++) {
		/* Load this into an array */
		for ($t = 1; $t <= 4; $t++) {
			$gethoursorder[$c][$t] = array(
				"category" . $c => $prow["time" . $c . "getfrom" . $t]
			);
		}
	}

	while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
		/* Start Creating Array with Totals Hours */
		if ($row["t1.en"] != $phours["empnumber"] && $phours["empnumber"] != "") {
			$phours       = checkpayrolltimeoverrides($phours, $prow);
			/* Before Balancing check if any export time have override values*/
			$phours       = balancepayrollhours($phours, $prow, $gethoursorder);
			/* Before Writing Record - do some funky balancing */
			$payrollhours = writerecord($phours, $payrollhours);
			/* Write record to array*/
			unset($phours);
			/* Clear record in prepeation for next employee */
		}
		$phours = totaldailyhours($row, $phours);
		/* Assign Values to Array Fields */
	}
	$phours       = checkpayrolltimeoverrides($phours, $prow);
	/* Before Balancing check if any export time have override values*/
	$phours       = balancepayrollhours($phours, $prow, $gethoursorder);
	/* Before Writing Last Record - do some funky balancing */
	$payrollhours = writerecord($phours, $payrollhours);
	/* Write Last Record to Array */
	return ($payrollhours);
}


function sql_select($prow, $pfromdate, $ptodate) {
	global $conn;
	global $phrsorder;
	global $phrsordtype;
	global $filter;
	global $filterfield;
	global $wholeonly;

	$filterstr = sqlstr($filter);
	if (!$wholeonly && isset($wholeonly) && $filterstr != '')
		$filterstr = "%" . $filterstr . "%";
	$sql = "SELECT t1.id as 't1.id', t1.processed as 't1.processed', t1.en as 't1.en', t2.en as 't2.en', t2.fn as 't2.fn', t2.ln as 't2.ln', t1.date as 't1.date', t1.desc as 't1.desc',
          t1.hours1 as 't1.hours1', t1.hours2 as 't1.hours2', t1.hours3 as 't1.hours3', t1.hours4 as 't1.hours4', t1.hours5 as 't1.hours5', t1.hours6 as 't1.hours6', t1.hours7 as 't1.hours7',
          t1.hours8 as 't1.hours8', t1.hours9 as 't1.hours9', t1.hours10 as 't1.hours10', t1.orhours1 as 't1.orhours1', t1.orhours2 as 't1.orhours2', t1.orhours3 as 't1.orhours3', t1.orhours4 as 't1.orhours4',
          t1.orhours5 as 't1.orhours5', t1.orhours6 as 't1.orhours6', t1.orhours7 as 't1.orhours7',t1.orhours8 as 't1.orhours8', t1.orhours9 as 't1.orhours9', t1.orhours10 as 't1.orhours10', t1.lunch as 't1.lunch',
          t1.orlunch as 't1.orlunch', t1.suen as 't1.suen', t1.stime as 't1.stime', t1.clockings as 't1.clockings', t2.deptid as 't2.deptid',  t2.payexporttype as 't2.payexporttype', t2.payid as 't2.payid',
          t1.awol as 't1.awol', t1.expected as 't1.expected', t1.comment as 't1.comment', t1.runningtotal as 't1.runningtotal', t3.desc as 't3.desc'
          FROM hour as t1 LEFT OUTER JOIN emp AS t2 ON (t1.en = t2.en) LEFT OUTER JOIN dept AS t3 ON (t2.deptid = t3.id)";
	$sql .= " where t1.date >= " . $pfromdate . " and t1.date <= " . $ptodate;
	$sql .= " and t2.payexporttype = " . $prow["id"];
//	$sql .= " and t2.deleted = 0 and t3.deleted = 0";

	$sql .= builduserlevelfilter('and', 't2', 't1');

	$sql .= " order by \"" . "t1.en" . "\"";
	$sql .= " " . "asc";
	$sql .= "; ";
	$_SESSION["currentbrowseselect"] = $sql;
	$res = $conn->query($sql) or die('<br/>Error in query string:<br/>' . $sql . '<br/>');
	return $res;
}


function totaldailyhours($row, $phours) {
	$phours["empnumber"]  = $row["t1.en"];
	$phours["paynumber"]  = $row["t2.payid"];
	$phours["empname"]    = $row["t2.fn"];
	$phours["empsurname"] = $row["t2.ln"];
	$phours["department"] = $row["t3.desc"];
	for ($i = 1; $i <= 10; $i++) {
		if ($row["t1.orhours" . $i] == -1) {
			$phours[$i] = $phours[$i] + $row["t1.hours" . $i];
		} else {
			$phours[$i] = $phours[$i] + $row["t1.orhours" . $i];
		}
	}
	$phours["runningtotal"] = $row["t1.runningtotal"];
	return ($phours);
}

function checkpayrolltimeoverrides($phours, $prow) {
	for ($i = 1; $i <= 10; $i++) {
		if ($prow["overridecat$i"] == 1) {
			$phours[$i] = $prow["overridetime$i"];
		}
	}
	return ($phours);
}

function balancepayrollhours($phours, $prow, $gethoursorder) {
	//global $prow;                                                /* Get processor settings from array already created*/

	/* 1 - First add time the categories together which must be included in a specific time category's total - a time category added from, is then to zero  */
	for ($b = 1; $b <= 4; $b++) {
		for ($c = 1; $c <= 10; $c++) {
			if ($prow["cat" . $c . "intime" . $b] == "1" && $b != $c) {
				$phours[$b]    = $phours[$b] + $phours[$c];
				$phoursorg[$c] = $phours[$c];
				$phours[$c]    = 0;
			}
		}
	}
	/* 2 - Then fill the time category to the required total from the 1st to the 4th nominated time category, Then push the time in eccess of the total into the nominated time category */
	for ($b = 1; $b <= 4; $b++) {
		if ($phours[$b] < intval($prow["stdtime$b"])) {
			for ($c = 1; $c <= 4; $c++) {
				$getfromtimecat = $gethoursorder[$b][$c]["category" . $b];
				if ($getfromtimecat == 0) {
					break;
				}
				if ($phours[$getfromtimecat] != 0) {
					$addtime = intval($prow["stdtime$b"]) - $phours[$b];
					if ($addtime >= $phours[$getfromtimecat]) {
						$phours[$b]              = $phours[$b] + $phours[$getfromtimecat];
						$phours[$getfromtimecat] = 0;
					} else {
						$phours[$b]              = intval($prow["stdtime$b"]);
						$phours[$getfromtimecat] = $phours[$getfromtimecat] - $addtime;
					}
				}
			}
		} else {
			if (intval($prow["stdtime" . $b]) != 0) {
				$overflowcat          = $prow["time" . $b . "overflowcat"];
				$phours[$overflowcat] = $phours[$overflowcat] + ($phours[$b] - intval($prow["stdtime" . $b]));
				$phours[$b]           = intval($prow["stdtime" . $b]);
			}
		}
	}

	/* 3 - First suntract time the categories originally included in a specific time category's total - the original time category added from' value is restored  */
	for ($b = 1; $b <= 4; $b++) {
		for ($c = 1; $c <= 10; $c++) {
			if ($prow["cat" . $c . "intime" . $b] == "1" && $b != $c) {
				$phours[$b] = $phours[$b] - $phoursorg[$c];
				$phours[$c] = $phours[$c] + $phoursorg[$c];
				unset($phoursorg[$c]);
			}
		}
	}
	return ($phours);
}


function writerecord($phours, $payrollhours) {
	/* Write Record to Array */
    if ($phours["empnumber"] != ""){
         $payrollhours[] = array(
        "empnumber" => $phours["empnumber"],
        "paynumber" => $phours["paynumber"],
        "empname" => $phours["empname"],
        "empsurname" => $phours["empsurname"],
        "department" => $phours["department"],
        "phours1" => $phours[1],
        "phours2" => $phours[2],
        "phours3" => $phours[3],
        "phours4" => $phours[4],
        "phours5" => $phours[5],
        "phours6" => $phours[6],
        "phours7" => $phours[7],
        "phours8" => $phours[8],
        "phours9" => $phours[9],
        "phours10" => $phours[10],
        "runningtotal" => $phours["runningtotal"]
        );
    }
	return ($payrollhours);
}
?>
